﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.EnergeticaNatura.dll;

using System;
using System.Transactions;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.EnergeticaNatura;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.EnergeticaNatura.BusinessObjects;
using Produmex.Sbo.Logex.EnergeticaNatura.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.EnergeticaNatura.Generators.IncomingPaymentGenerators;
using Produmex.Sbo.Logex.EnergeticaNatura.BusinessObjects.Definitions.Tables;



namespace AddUpdateData
{
    class Program
    {
		private static string CONNECTION_STRING = "Server=PDMX-POLLAKA\\MSSQL11;CompanyDB=Test_20170215;ExtraDb=PMX_Test_20170215;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2012;DBCultureInfo=en-US;LicenseServer=PDMX-POLLAKA:30000";

        //static string SCRIPT_ROOT = @"..\WorkflowScripts";


        static void Main( string[] args )
        {
            Console.WriteLine("AddUpdateData application started...");

            //TestIncomingPayment(123);

            using (SboConnection conn = new SboConnection(CONNECTION_STRING))
            {
                conn.Open(); //Open connection to SAP
                Console.WriteLine("Connection is open to database");
                Console.WriteLine("Add update UDF: PmxShippingType");
                AddUpdateUserFieldsNotInTransaction(conn, typeof(PmxShippingTypeEN));

            }

            using ( TransactionScope scope = PmxDbConnection.GetNewTransactionScope() )
            {
                using ( SboConnection conn = new SboConnection( CONNECTION_STRING ) )
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine( "Client Parameters" );

                    PmxDbVersionUpdaterProvider dbVersionProv = new PmxDbVersionUpdaterProvider(conn);

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.BPOST_FILE_PATH,
                        "EN - BPost file location",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"C:\Produmex\Labels\Labelfile.txt",
                        PmxExtensionParameterCodesEN.BPOST_FILE_PATH.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.BPOST_PRINTER,
                        "EN - BPost printer",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"PDFCreator",
                        PmxExtensionParameterCodesEN.BPOST_PRINTER.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.DPD_OUT_DIR,
                        "EN - DPD output directory",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"C:\Produmex\Interface\Out\DPD",
                        PmxExtensionParameterCodesEN.DPD_OUT_DIR.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.LAPOSTE_OUT_DIR,
                        "EN - La Poste output directory",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"C:\Produmex\Interface\Out\LaPoste",
                        PmxExtensionParameterCodesEN.LAPOSTE_OUT_DIR.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.LAPOSTE_WEBSERVICE_USER,
                        "EN - La Poste webservice username",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"",
                        PmxExtensionParameterCodesEN.LAPOSTE_WEBSERVICE_USER.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.LAPOSTE_WEBSERVICE_PASSWORD,
                        "EN - La Poste webservice userpassword",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"",
                        PmxExtensionParameterCodesEN.LAPOSTE_WEBSERVICE_PASSWORD.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.LAPOSTE_LABEL_PRINTER,
                        "EN - La Poste printer name for label",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"PDFCreator",
                        PmxExtensionParameterCodesEN.LAPOSTE_LABEL_PRINTER.Substring(3));

                    dbVersionProv.AddUpdateExtensionParameter(PmxExtensionParameterCodesEN.LAPOSTE_DOCUMENT_PRINTER,
                        "EN - La Poste printer name for CN23 document",
                        Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.PACKING_THINCLIENT_PARAMETERSET,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
                        @"PDFCreator",
                        PmxExtensionParameterCodesEN.LAPOSTE_DOCUMENT_PRINTER.Substring(3));

                }

                //Complete transaction
                scope.Complete();
            }

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (SboConnection conn = new SboConnection(CONNECTION_STRING))
				{
					conn.Open();
					// * UDF's *
					Console.WriteLine("Add update UDF: ShippingBarcodeType");
					SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);
					udfProv.AddUpdateUserfield(PmxSalesInvoiceTable.NAME, new SboColumnDefinitionAttribute(
						PmxSalesInvoiceENTable.Columns.ShippingBarcode.NAME,
						PmxSalesInvoiceENTable.Columns.ShippingBarcode.DESCR,
						PmxSalesInvoiceENTable.Columns.ShippingBarcode.TYPE,
						PmxSalesInvoiceENTable.Columns.ShippingBarcode.SIZE,
						PmxSalesInvoiceENTable.Columns.ShippingBarcode.SUB_TYPE));
					// * UDF's *

					scope.Complete();
				}
			}

			using (SboConnection conn = new SboConnection(CONNECTION_STRING))
			{
				conn.Open();

				// * UDT's *
				Console.WriteLine("Add update UDT: ShippingBarcodeTable");
				AddUpdateUserDefinedTable(typeof(PmxShippingBarcodeEN), conn);
				AddUpdateUserDefinedObject(typeof(PmxShippingBarcodeEN), conn);

				Console.WriteLine("Add update UDT: CountryCodesForCN23docENTable");
				AddUpdateUserDefinedTable(typeof(PmxCountryCodesForCN23docEN), conn);
				AddUpdateUserDefinedObject(typeof(PmxCountryCodesForCN23docEN), conn);
				// * UDT's *

			}

            //PMX connection
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open(); //Open connection to SAP
                    Console.WriteLine("Workflows");

                 //   AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "SalesInvoiceCreatedHookScript",
                 //       SCRIPT_ROOT + @"\WorkflowScript_SalesInvoiceCreatedHookScript\WorkflowScript_SalesInvoiceCreatedHookScript.cs", dbConn);



                    AddUpdateExtension("ENNA_IPG", "Energetica Natura Incoming payment generator", typeof(Produmex.Sbo.Logex.EnergeticaNatura.Generators.IncomingPaymentGenerators.IncomingPaymentEnergeticaNaturaGenerator), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINCOMINGPAYMENTGENERATOR, dbConn);

                }

                //Complete transaction
                scope.Complete();
            }

            Console.WriteLine("Done ...");

        }

		private static void AddUpdateUserDefinedTable(Type type, SboConnection conn)
		{
			SboUserTableMDProvider userTableMDProv = new SboUserTableMDProvider(conn);
			userTableMDProv.AddUpdateBO(type);
		}

		private static void AddUpdateUserDefinedObject(Type type, SboConnection conn)
		{
			SboUserObjectMDProvider userObjectMDProv = new SboUserObjectMDProvider(conn);
			if (userObjectMDProv.AddUpdateBO(type))
			{
				//Rerun in case of delete of columns
				userObjectMDProv.AddUpdateBO(type);
			};
		}

        private static void TestIncomingPayment(int docEntryInvoice)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP


                    IncomingPaymentEnergeticaNaturaGenerator gen = new IncomingPaymentEnergeticaNaturaGenerator(conn);

                    gen.AddIncomingPayment(null, docEntryInvoice, null, "13");
                }



                scope.Complete();
            }
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnection conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider( conn );
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO( code );
                if ( extension == null )
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName( type );
                if ( newBO )
                {
                    prov.AddBO( extension );
                }
                else
                {
                    prov.UpdateBO( extension, false, false );
                }
            }
            finally
            {
                if ( extension != null ) extension.Dispose();
            }
        }

        private static void AddUpdateUserFieldsNotInTransaction(SboConnection conn, params Type[] types)
        {
            SboUserFieldMDProvider userFieldMDProv = new SboUserFieldMDProvider(conn);
            //System.Data.Common.DbTransaction transaction = null;
            try
            {
                //transaction = this.Connection.BeginTransaction();
                userFieldMDProv.AddUpdateUserFields(types);

                //Commit transaction
                //transaction.Commit();
            }
            catch (Exception)
            {
                //if (transaction != null) transaction.Rollback();
                throw;
            }
        }


        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }
        }


    }
}
